#!/usr/bin/perl -w
#attempting to make paup* blocks with same random numbs.

my $count = 0;
my $input;
my $number;
my $delset;
my $delete1;
my $tre;
my $treenum;
my $limit = 3; # the number of alleles you want to subsample
my $outtre = "subTree"; #a prefix for all output trees

srand(time|$$);
for my $k (1..5)
{ #number of replicates in the analysis

do {
$delset='';
$outtre2 = $outtre.".ALL$limit.$k.tre"; #adds the replicate number to the prefix

my @numbersA = (1..10); 	#total ind for first species, don't include 1 if outgroup
my %listA = ();
while (keys %listA < $limit) {
   $listA{$numbersA[rand @numbersA]}=1;
} 

my @numbersB = (11..20); 	#total ind speciesB
my %listB = ();
while (keys %listB < $limit) {
   $listB{$numbersB[rand @numbersB]}=1;
} 

my @numbersC = (21..30); 	#total ind speciesC
my %listC = ();
while (keys %listC < $limit) {
   $listC{$numbersC[rand @numbersC]}=1;
}

my @numbersD = (31..39); 	#total ind speciesD
my %listD = ();
while (keys %listD < $limit) {
   $listD{$numbersD[rand @numbersD]}=1;
}
my @numbersE = (40..49); 	#total ind speciesD
my %listE = ();
while (keys %listE < $limit) {
   $listE{$numbersE[rand @numbersE]}=1;
}
my @numbersF = (50..55); 	#total ind speciesD
my %listF = ();
while (keys %listF < $limit) {
   $listF{$numbersF[rand @numbersF]}=1;
}
my @keyA = keys %listA;
my @keyB = keys %listB;
my @keyC = keys %listC;
my @keyD = keys %listD;
my @keyE = keys %listE;
my @keyF = keys %listF;


my @keyarray = (@keyA, @keyB, @keyC, @keyD, @keyE, @keyF);

sub find_dups($$){
  		my %hash1 = map { $_=>1 } @{+shift};
  		return grep { !$hash1{$_} }  @{+shift};
		}

print "$outtre2 @keyarray \n"; 

###WRITING THE PAUP INPUT FILES###
open paupINPUT, ">>/Users/shird/Desktop/StemSubs/paupfeed.subs.ALL$limit.$k ";
print paupINPUT "log file=log.log;\n";	
print paupINPUT "execute /Users/shird/Desktop/StemSubs/APE2.nex;\n"; 
print paupINPUT "set crit=l rootmethod=midpoint maxtrees=1; lset clock=y;\n";
print paupINPUT "delete all; undelete @keyarray ;\n";
print paupINPUT "hs nbest=1 swap=spr; savetrees file=$outtre2 root=yes format=altnex brlens=yes maxdecimals=6 append=yes;\n";	#taxablk=yes
print paupINPUT "undelete all /cleartrees=yes;\n\n";
close paupINPUT;

system("/Users/shird/Desktop/StemSubs/paup -n </Users/shird/Desktop/StemSubs/paupfeed.subs.ALL$limit.$k >out.txt "); #run replicate through paup*

system("cd /Users/shird/Desktop/StemSubs | grep 'PAUP_' /Users/shird/Desktop/StemSubs/$outtre2 >>/Users/shird/Desktop/StemSubs/STEMinput.ALL$limit.$k.tre");
system("perl -pi -e s/'\&R'/'1\.0'/g STEMinput.ALL$limit.$k.tre;");
system("perl -pi -e s/' '//g STEMinput.ALL$limit.$k.tre;");
system("perl -pi -e s/'treePAUP_1='//g STEMinput.ALL$limit.$k.tre;");
system("perl -pi -e s/':0;'/';'/g STEMinput.ALL$limit.$k.tre;");


}
}
